<!doctype html>
<html lang="ru" xmlns="http://www.w3.org/1999/html">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Laboratory work 1</title>

    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script src="https://code.highcharts.com/highcharts.src.js"></script>
    <script src="https://code.highcharts.com/modules/boost.js"></script>

    <!-------STYLES------->

    <!--Fonts -->
    <style>
        @import url('https://fonts.googleapis.com/css2?family=Roboto:wght@100;300;400;500&display=swap');
    </style>

    <!--Reset styles-->
    <style>
        button {
            border: none;
            margin: 0;
            padding: 0;
            width: auto;
            overflow: visible;

            background: transparent;

            /* inherit font & color from ancestor */
            color: inherit;
            font: inherit;

            /* Normalize `line-height`. Cannot be changed from `normal` in Firefox 4+. */
            line-height: normal;

            /* Corrects font smoothing for webkit */
            -webkit-font-smoothing: inherit;
            -moz-osx-font-smoothing: inherit;

            /* Corrects inability to style clickable `input` types in iOS */
            -webkit-appearance: none;
            outline: none;
            border-radius: 0;
        }
        button::-moz-focus-inner,
        input::-moz-focus-inner {
            border: 0;
            padding: 0;
        }
    </style>

    <!--Layout base-->
    <style>
        html{
            width: 100%;
            height: 100%;
        }

        * {
            margin: 0;
            padding: 0;
        }

        .content-root {
            min-width: 100%;
            min-height: 100%;
            display: flex;
            flex-direction: column;
            justify-content: center;
            align-items: center;
        }

        .layout__panel {
            display: flex;
            flex-direction: row;
            justify-content: center;
            width: 100%;
            background-color: #587d7d;
            padding-top: 10px;
            padding-bottom: 10px;
        }

        .layout__content {
            max-width: 768px;
            flex-direction: column;
            background-color: #e9e9e9;
            flex: 1;
        }


        @media screen and (max-width: 768px){
            .layout__content {
                width: 100%;
            }
        }
    </style>

    <!--Content styles-->
    <style>

        .header {
            font-family: Roboto, sans-serif;
            font-size: 16px;
        }

        .panel__caption {
            color: whitesmoke;
            font-family: Roboto, sans-serif;
            font-size: 24px;
        }

        .panel__caption--font--small {
            font-size: 14px;
        }

        .task {
            width: 100%;
        }

        .work__description {
            font-family: Roboto, sans-serif;
            font-weight: 400;
            font-size: 18px;
            padding: 10px 5px 10px 5px;
        }

        .description__header {
            font-weight: 500;
            margin-top: 5px;
            margin-bottom: 20px;
        }

        .description__list {
            margin-top: 5px;
            margin-bottom: 5px;
        }

        .list__item {
            font-style: italic;
            font-size: 15px;
            font-weight: 300;
            list-style-position: inside;
        }

        .task__header {
            font-size: 18px;
            font-family: Roboto, sans-serif;
            font-weight: 400;
            margin-bottom: 20px;
        }

        .container {
            display: flex;
            flex-wrap: wrap;
        }

        .container--direction--row {
            flex-direction: row;
        }

        .container--justify--space-around {
            justify-content: space-around;
        }

        .container--align--start {
            align-items: flex-start;
        }

        .container__item {
            display: flex;
        }

        .container__item--direction--column{
            flex-direction: column;
        }

        .container__item--align--center {
            align-items: center;
        }

        .container__item--justify--center{
            justify-content: center;
        }

        .form__field {
            display: block;
        }

        .form__field + .form__field {
            margin-top: 5px;
        }

        .field__caption {
            display: block;
            font-size: 14px;
            font-family: Roboto, sans-serif;
            font-weight: 300;
            padding-top: 5px;
            padding-bottom: 2px;
            width: 100%;
        }

        .field__input {
            box-sizing: border-box;
            width: 100%;
        }

        .form__button {
            font-size: 15px;
            font-family: Roboto, sans-serif;
            margin: 10px 0 10px 0;
            padding: 2px 15px 2px 15px;
            width: 100%;
            font-weight: 300;
            background-color: #3a383c;
            color: #c6bfcb;
        }

        .form__button:active {
            background-color: #676467;
        }

        .task__media {
            height: 400px;
            border-top: #3a383c 1px solid;
            border-bottom: #3a383c 1px solid;
            -webkit-box-shadow: 0 0 27px -10px rgba(0,0,0,0.75);
            -moz-box-shadow: 0 0 27px -10px rgba(0,0,0,0.75);
            box-shadow: 0 0 27px -10px rgba(0,0,0,0.5);
            overflow: hidden;
        }

        .media__placeholder {
            width: 100%;
            height: 100%;
            display: flex;
            justify-content: center;
            align-items: center;
            font-family: Roboto, sans-serif;
            font-size: 20px;
            color: rgba(0,0,0,0.25);
            background-color: #919090;
        }

    </style>

    <!--Utils-->
    <style>
        hr {
            height: 1px;
            width: 100%;
            border-top: 1px solid black;
            box-sizing: border-box;
        }


        .space--vertical--25 {
            width: 100%;
            box-sizing: border-box;
            height: 25px;
        }

        .space--vertical--50 {
            width: 100%;
            box-sizing: border-box;
            height: 50px;
        }
    </style>


    <!-------CODE------->

    <!--Simpson method-->
    <script>
        document.addEventListener('DOMContentLoaded', () => {
            document.getElementById('SimpsonParameters')
            .addEventListener('submit', async event => {
                event.preventDefault()

                const formData = {}
                for (const el of event.target)
                    if (el.name) formData[el.name] = el.value

                const requestData = {
                    headers:{},
                    parameters: {
                        segment: {
                            start: parseFloat(formData.segmentStart),
                            end: parseFloat(formData.segmentEnd)
                        },
                        segmentsCount: parseInt(formData.segmentsCount),
                        equation: formData.equation
                    }
                }

                const response = await axios.post('<%=BASE_URL + SIMPSON_METHOD_API %>', requestData)
                    .then(r => r)
                    .catch(err => {
                        if (err.response)
                            return err.response

                        alert('Unknown error, report about this case to creator')
                        throw Error(err)
                    })

                if (response.status !== 200 || response.data.headers.type === 'ERROR')
                    return alert(`Error: ${response.data.payload.reason}`)

                const requestResult = response.data

                const resultFormFields = {}

                const resultForm = document.getElementById('SimpsonResult')
                for (const el of resultForm)
                    if (el.name) resultFormFields[el.name] = el

                resultFormFields.measurementError.value = requestResult.headers.evaluatingError

                resultFormFields.numericResult.value = requestResult.data.numericResult

                const chartData = requestResult.data.points.map(p => {
                    return {
                        ...p,
                        color: p.coefficient === 1 ? 'black' :
                                p.coefficient === 2 ? 'green' : 'red'
                    }
                })

                console.log(requestResult)

                console.log('Chart began to build')

                Highcharts.chart({
                    title: {
                        text: 'Simpson method curve'
                    },
                    chart: {
                        renderTo: 'SimpsonChart',
                        backgroundColor: 'transparent'
                    },
                    series: [{
                        type: 'line',
                        data: chartData,
                        name: 'Integral',
                        tooltip: {
                            headerFormat: '',
                            pointFormatter: function (){
                                return  `<span style="color:${this.color}">● Integral point</span></br>` +
                                        `X: <b>${this.x}</b></br>` +
                                        `Y: <b>${this.y}</b></br>` +
                                        `Coefficient: ${this.coefficient}`
                            }
                        }
                    }],
                    xAxis: {
                        endOnTick: true,
                        tickInterval: Math.abs(requestResult.headers.segment.end - requestResult.headers.segment.start) / requestResult.headers.segmentsCount
                    }
                })
            })
        })
    </script>

    <!--Monte-Carlo method-->
    <script>

        document.addEventListener('DOMContentLoaded', () => {
            document.getElementById('MonteCarloParameters')
                .addEventListener('submit', async event => {
                    event.preventDefault()

                    const formData = {}
                    for (const el of event.target)
                        if (el.name) formData[el.name] = el.value

                    const requestData = {
                        headers:{
                            receivePoints: true
                        },
                        parameters: {
                            equation: formData.equation,
                            segment: {
                                start: parseFloat(formData.segmentStart),
                                end: parseFloat(formData.segmentEnd)
                            },
                            throwsCount: parseInt(formData.throwsCount),
                            accuracy: parseInt(formData.accuracy),
                            measurementErrorRepeats: parseInt(formData.measurementErrorRepeats),
                            periodicalInitStep: parseFloat(formData.periodicalInitStep)
                        }
                    }

                    const response = await axios.post('<%=BASE_URL + MONTE_CARLO_METHOD_API %>', requestData)
                        .then(r => r)
                        .catch(err => {
                            if (err.response)
                                return err.response

                            alert('Unknown error, report about this case to creator')
                            throw Error(err)
                        })

                    if (response.status !== 200 || response.data.headers.type === 'ERROR')
                        return alert(`Error: ${response.data.payload.reason}`)

                    const requestResult = response.data

                    const resultFormFields = {}

                    const resultForm = document.getElementById('MonteCarloResult')
                    for (const el of resultForm)
                        if (el.name) resultFormFields[el.name] = el

                    resultFormFields.sharedArea.value = requestResult.data.sharedArea

                    resultFormFields.numericResult.value = requestResult.data.numericResult

                    resultFormFields.measurementError.value = requestResult.data.measurementError

                    const hitThrows = requestResult.data.points.filter(p => p.isHit)
                        .map(p => [p.x, p.y])

                    const missedThrows = requestResult.data.points.filter(p => !p.isHit)
                        .map(p => [p.x, p.y])


                    console.log(requestResult)

                    console.log('Chart began to build')

                    Highcharts.chart({
                        title: {
                            text: 'Monte-Carlo method throws'
                        },
                        chart: {
                            renderTo: 'MonteCarloChart',
                            zoomType: 'xy',
                            backgroundColor: 'transparent'
                        },
                        boost: {
                            useGPUTranslations: true,
                            usePreAllocated: true
                        },
                        series: [
                            {
                                type: 'scatter',
                                data: missedThrows,
                                color: 'red',
                                name: 'Missed throws',
                                tooltip: {
                                    headerFormat: '',
                                    pointFormatter: function (){
                                        return  `<b>Missed throw</b></br>` +
                                                `X: <b>${this.x}</b></br>` +
                                            `Y: <b>${this.y}</b></br>`
                                    }
                                }
                            },
                            {
                                type: 'scatter',
                                data: hitThrows,
                                color: 'green',
                                name: 'Hit throws',
                                tooltip: {
                                    headerFormat: '',
                                    pointFormatter: function (){
                                        return  `<b>Hit throw</b></br>` +
                                            `X: <b>${this.x}</b></br>` +
                                            `Y: <b>${this.y}</b></br>`
                                    }
                                }
                            }
                        ],
                        xAxis: {
                            min: requestResult.headers.area.start,
                            max: requestResult.headers.area.end,
                        },
                        yAxis: {
                            min: requestResult.headers.area.bottom,
                            max: requestResult.headers.area.top,
                        }
                    })
                })
        })
    </script>
</head>
<body class="content-root">
    <header class="layout__panel">
        <div class="panel__caption">Laboratory work #1</div>
    </header>
    <section class="layout__content">
        <!--Laboratory work description-->
        <article class="work__description">
            <div class="description__header">Laboratory work N1. Calculating numeric value of integrals.</div>
            Tasks:
            <ul class="description__list">
                <li class="list__item">Create implementation of Simpson algorithm to integral calculating.</li>
                <li class="list__item">Create implementation of Monte-Carlo algorithm.</li>
                <li class="list__item">Create visualisation of Monte-Carlo algorithm.</li>
            </ul>
        </article>
        <hr>
        <div class="space--vertical--25"></div>
        <!--Simpson task-->
        <article class="task">
            <div class="task__header">1. Simpson Method</div>
            <div class="container container--direction--row container--justify--space-around container--align--start">
                <div class="container__item container__item--direction--column container__item--align--center container__item--justify--center">
                    <div class="header">Enter values to calculate</div>
                    <form id="SimpsonParameters">
                        <label class="form__field">
                            <span class="field__caption">Equation</span>
                            <input type="text" class="form__field" name="equation" value="x + cos(x)"/>
                        </label>
                        <label class="form__field">
                            <span class="field__caption">Segment start</span>
                            <input type="text" class="form__field" name="segmentStart" value="0">
                        </label>
                        <label class="form__field">
                            <span class="field__caption">Segment end</span>
                            <input type="text" class="form__field" name="segmentEnd" value="1.6">
                        </label>
                        <label class="form__field">
                            <span class="field__caption">Segments count</span>
                            <input type="text" class="form__field" name="segmentsCount" value="20">
                        </label>
                        <button class="form__button">Calculate</button>
                    </form>
                </div>
                <div class="container__item container__item--direction--column container__item--align--center container__item--justify--center">
                    <div class="header">Calculation result</div>
                    <form id="SimpsonResult">
                        <label class="form__field">
                            <span class="field__caption">Measurement error</span>
                            <input type="text" name="measurementError" readonly value=""/>
                        </label>
                        <label class="form__field">
                            <span class="field__caption">Numeric result</span>
                            <input type="text" name="numericResult" readonly value=""/>
                        </label>
                    </form>
                </div>
            </div>
            <div id="SimpsonChart" class="task__media">
                <div class="media__placeholder">Chart will be displayed here</div>
            </div>
        </article>
        <div class="space--vertical--50"></div>
        <hr>
        <!--Monte-Carlo task-->
        <article class="task">
            <div class="task__header">2. Monte-Carlo method</div>
            <div class="container container--direction--row container--align--start container--justify--space-around">
                <div class="container__item container__item--direction--column container__item--justify--center container__item--align--center">
                    <div class="header">Enter values to calculate</div>
                    <form id="MonteCarloParameters">
                        <label class="form__field">
                            <span class="field__caption">Equation</span>
                            <input type="text" class="field__input" name="equation" value="x + cos(x)">
                        </label>
                        <label class="form__field">
                            <span class="field__caption">Segment start</span>
                            <input type="text" class="field__input" name="segmentStart" value="0">
                        </label>
                        <label class="form__field">
                            <span class="field__caption">Segment end</span>
                            <input type="text" class="field__input" name="segmentEnd" value="1.6">
                        </label>
                        <label class="form__field">
                            <span class="field__caption">Throws count</span>
                            <input type="text" class="field__input" name="throwsCount" value="10000">
                        </label>

                        <label class="form__field">
                            <span class="field__caption">Error measurement repeats</span>
                            <input type="text" class="field__input" name="measurementErrorRepeats" value="10">
                        </label>
                        <label class="form__field">
                            <span class="field__caption">Extremes calc accuracy sings</span>
                            <input type="text" class="field__input" name="accuracy" value="5">
                        </label>
                        <label class="form__field">
                            <span class="field__caption">Extremes calc initial step</span>
                            <input type="text" class="field__input" name="periodicalInitStep" value="0.00001">
                        </label>
                        <button class="form__button">Calculate</button>
                    </form>
                </div>
                <div class="container__item container__item--direction--column container__item--justify--center container__item--align--center">
                    <div class="header">Calculation result</div>
                    <form id="MonteCarloResult">
                        <label class="form__field">
                            <span class="field__caption">Numeric result</span>
                            <input type="text" class="field__input" name="numericResult" readonly/>
                        </label>
                        <label class="form__field">
                            <span class="field__caption">Shared area</span>
                            <input type="text" class="field__input" name="sharedArea" readonly/>
                        </label>
                        <label class="form__field">
                            <span class="field__caption">Measurement error</span>
                            <input type="text" class="field__input" name="measurementError" readonly/>
                        </label>
                    </form>
                </div>
            </div>
            <div class="task__media" id="MonteCarloChart">
                <div class="media__placeholder">
                    Chart will be displayed here
                </div>
            </div>
        </article>
        <div class="space--vertical--25"></div>
    </section>
    <footer class="layout__panel">
        <div class="panel__caption panel__caption--font--small">Alexey Moskalenko 2021. CFU Vernadskogo.</div>
    </footer>
</body>
</html>
